#!/bin/sh
# ./display.sh  - ABACUS operator interface 
# the next line restarts using wish \
exec wish "$0" "$@"
# -geometry +0+0
########################################################################
#
# trendb.tcl Trend using the Blt stuff
#
# Initial version 000419
# 
# 
########################################################################
# "$Id: trendb.tcl,v 1.7 2000/09/05 13:31:50 abacus Exp abacus $"

package require BLT
if { $tcl_version >= 8.0 } {
    namespace import blt::*
    namespace import -force blt::tile::*
}

set NODE	uc70
set NODE	uc80
set NODE	localhost
if { $argc > 0 } { set NODE       [lindex $argv 0] }
if { $argc > 1 } { set thefile    [lindex $argv 1] } else { set thefile "" }



#set NODE	pm3co
set TRENDFILESDIR /home/abacus/trendfiles/

set font  -adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*

set w .
#cd /home/abacus/trenddatafiles/
####cd /home/abacus/

wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile"
wm iconname $w "Trend"
wm geometry $w 820x640+0+0
#wm geometry $w 800x640
#wm geometry $w 1024x800+8+8

set c .frame.c
set tagnames xaxistext
set updateint 10

##################### bash-net substitute ############################

proc BashNetReader { sock } {
  global BashNetforever BashNetReaderResult
  gets $sock line
  if { $line == "e17971e17971" } {
    set BashNetforever 1
    catch {close $sock}
#puts stdout "BashNetReader: close $sock"
    catch {close $sock}
    return line
  }
  append BashNetReaderResult "$line\n"
  return line
}

proc BashNet { sock args } {
  global BashNetforever BashNetReaderResult

    set BashNetReaderResult ""
    set sock [socket $sock 9000]
#puts stdout "BashNet: set sock \[socket $sock 9000\]" 
    fconfigure $sock -blocking 1 -buffering line -translation lf 
    puts $sock "[lrange $args 0 end];echo;echo e17971e17971;"
    flush $sock

    fileevent $sock readable [list BashNetReader $sock]
    vwait BashNetforever
    return $BashNetReaderResult
}

proc BashNet-err { sock args } {
#  return [exec /home/abacus/bashnet $sock [lrange $args 0 end]]
  return [exec /home/abacus/bashnet $sock $args ]
}
##################### end of bash-net substitute ############################

label ${w}msg -font $font -justify left 
#-text "This is ${w}msg /home/abacus/t2.sh" -wraplength 5i 
pack ${w}msg -side bottom

frame ${w}t
pack ${w}t  -side top -anchor nw
button ${w}t.newp -text "New trend page" -command {
 exec  [info script]  -geometry +0+0 &
 exit
 }

########################## Start of file menu stuff ##############

 ######     #    #       ######          #    #  ######  #    #  #    #
 #          #    #       #               ##  ##  #       ##   #  #    #
 #####      #    #       #####           # ## #  #####   # #  #  #    #
 #          #    #       #               #    #  #       #  # #  #    #
 #          #    #       #               #    #  #       #   ##  #    #
 #          #    ######  ######          #    #  ######  #    #   ####


menubutton ${w}t.file -text "FILE" -menu ${w}t.file.m
menu ${w}t.file.m -tearoff 0
${w}t.file.m add separator

# clearvars
${w}t.file.m add command -label "Open Trend File" -command { choose_trend }
proc choose_trend {} {
 global xmag ymag canvasbg updateint xpoints SAMPLES 
 global NODE  acb trendfile ymax ymin colour width linesymbol
 global thefile timb w
 global TRENDFILESDIR
 set thefile [tk_getOpenFile -initialdir $TRENDFILESDIR]
 if { $thefile != ""} { 
   after cancel [after info]
   clearvars
   catch { foreach tagname $tagnames {catch { $c delete line -tag $tagname } } }
   source $thefile
   catch { .frame.graph xaxis configure -min -$xpoints -max 0 }
   catch { .frame.graph configure -backgound $canvasbg }

   for {set x 1 } {$x < 10} {incr x} {
   catch { .frame.graph element delete line$x } }
   for {set x 1 } {$x < 10} {incr x} {
   catch {  .frame.graph element create  line$x -pixels $width($x)}  }

   catch { drawlines }
   catch { get_data }
   }
 catch { set timb [lindex [split $trendfile(0) '.'] 2] }
 wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile"
}

${w}t.file.m add command -label "Revert" -command { revert_to_org }
proc revert_to_org {} {
 global xmag ymag canvasbg updateint xpoints SAMPLES 
 global NODE  acb trendfile ymax ymin colour width linesymbol
 global thefile timb w
 global TRENDFILESDIR
 if { $thefile == ""} { choose_trend } else { 
   after cancel [after info]
   clearvars
   catch { foreach tagname $tagnames {catch { $c delete line -tag $tagname } } }
   source $thefile
   catch { .frame.graph xaxis configure -min -$xpoints -max 0 }
   catch { .frame.graph configure -backgound $canvasbg }

   for {set x 1 } {$x < 10} {incr x} {
   catch { .frame.graph element delete line$x } }
   for {set x 1 } {$x < 10} {incr x} {
   catch { .frame.graph element create  line$x -pixels $width($x)}  }

   catch { drawlines }
   catch { get_data }
   catch { do_Motion %W 0 0 }
   }
 catch { set timb [lindex [split $trendfile(0) '.'] 2] }
 wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile"
}

${w}t.file.m add separator
${w}t.file.m add command -label "Save Trend file" -command {
 global xmag ymag canvasbg updateint xpoints SAMPLES 
 global NODE  acb trendfile ymax ymin colour width linesymbol
 global TRENDFILESDIR thefile
 set filename [tk_getSaveFile -initialdir $TRENDFILESDIR  -initialfile [file tail $thefile]]
 if { $filename != ""} { 
   set fileId [open $filename w]
   set thefile $filename
   puts $fileId [format "#!/home/abacus/trendb.tcl"]
   puts $fileId "# $filename created by /home/abacus/trendb.tcl\n# at [BashNet $NODE date]\n"
   puts $fileId "set xmag	$xmag"
   puts $fileId "set ymag	$ymag"
   puts $fileId "set canvasbg	$canvasbg"
   puts $fileId "set updateint	$updateint"
   puts $fileId "set xpoints	$xpoints"
   puts $fileId "set SAMPLES	$SAMPLES"
   puts $fileId "set NODE	$NODE"
   puts $fileId "set timb	$timb"

   puts $fileId ""
   
   foreach n {0 1 2 3 4 5 6 7 8 9} {
   	puts $fileId "set acb($n)    		$acb($n)"
   	puts $fileId "set trendfile($n)		$trendfile($n)"
   	puts $fileId "set ymax($n)   		$ymax($n)"
   	puts $fileId "set ymin($n)   		$ymin($n)"
   	puts $fileId "set colour($n) 		$colour($n)"
   	puts $fileId "set width($n)  		$width($n)"
   	puts $fileId "set linesymbol($n)  	$linesymbol($n)\n"
   }
   close $fileId 
 }
 wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile"
}

${w}t.file.m add command -label "Save data to text file" -command { tableout }


${w}t.file.m add command -label "Update Now" -command { get_data }
${w}t.file.m add separator
#${w}t.file.m add command -label "toggle crosshairs" -command {.frame.graph crosshairs toggle }
${w}t.file.m add command -label "Trend Options" -command {trend_options}
proc trend_options {} {
    global xmag ymag canvasbg updateint xpoints SAMPLES 
    global NODE  acb trendfile ymax ymin colour width linesymbol
    global ygroup ymin ymax do_b1_x acb
    global NODE thefile
    global TRENDFILESDIR
    
    catch { destroy .opt }
    toplevel .opt
    label .opt.label -text "Trend Options"
    
    button .opt.cancel -text "Close" -command { catch { destroy .opt } }
    
    entry .opt.enode 
    .opt.enode insert end "$NODE" 
    button .opt.bnode -text "Change NODE" -command {
      global NODE
      set NODE [.opt.enode get]
    }
    
    entry .opt.efreq 
    .opt.efreq insert end "$updateint" 
    button .opt.bfreq -text "Change Update interval" -command {
      global updateint
      set updateint [.opt.efreq get]
    }
    
    button .opt.bgcolour -text "Background Colour" -command {
      setcanvasbg
    }
    
#    button .opt.crosshairs -text "toggle crosshairs" -command {
#      .frame.graph crosshairs toggle 
#    }
#    
    
    grid .opt.label -row 0 -column 0 -rowspan 1 -columnspan 2 -sticky news
    grid .opt.enode -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
    grid .opt.bnode -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
    grid .opt.bgcolour -row 2 -column 0 -rowspan 1 -columnspan 2 -sticky news
    grid .opt.efreq -row 3 -column 0 -rowspan 1 -columnspan 1 -sticky news
    grid .opt.bfreq -row 3 -column 1 -rowspan 1 -columnspan 1 -sticky news
#    grid .opt.crosshairs -row 4 -column 0 -rowspan 1 -columnspan 2 -sticky news
    grid .opt.cancel -row 9 -column 1 -rowspan 1 -columnspan 1 -sticky news
    
}
################## End of Options button ###############3
${w}t.file.m add separator
${w}t.file.m add command -label "CLOSE" -command { exit }
###################### end of file menu ##################33

 ######  #    #  #####            ####   ######
 #       ##   #  #    #          #    #  #
 #####   # #  #  #    #          #    #  #####
 #       #  # #  #    #          #    #  #
 #       #   ##  #    #          #    #  #
 ######  #    #  #####            ####   #


 ######     #    #       ######          #    #  ######  #    #  #    #
 #          #    #       #               ##  ##  #       ##   #  #    #
 #####      #    #       #####           # ## #  #####   # #  #  #    #
 #          #    #       #               #    #  #       #  # #  #    #
 #          #    #       #               #    #  #       #   ##  #    #
 #          #    ######  ######          #    #  ######  #    #   ####




set SAMPLES 2000
set SAMPLES 1000
set SAMPLES 500

menubutton ${w}t.samples -text "No. of Samples" -menu ${w}t.samples.m  -underline 0
menu ${w}t.samples.m -tearoff 0
${w}t.samples.m add separator
foreach sampl { 500 1000 2000  } {
	${w}t.samples.m add radiobutton -label  "$sampl"\
	 -variable SAMPLES -value $sampl \
         -command { #catch { ${w}t.samples configure -text "$sampl Samples" } }
}
#catch { ${w}t.samples configure -text "$sampl Samples" }

menubutton ${w}t.timb -text "Timebase" -menu ${w}t.timb.m  -underline 0
menu ${w}t.timb.m -tearoff 0
${w}t.timb.m add separator
set timbs [BashNet $NODE /bin/ls /home/abacus/trenddatafiles/ | cut -c 11-13 | sort -n | uniq]

foreach tim $timbs {
	${w}t.timb.m add radiobutton -label  "$tim secs/sample"\
         -variable timb -value $tim \
         -command {
           foreach x {0 1 2 3 4 5 6 7 8 9} {
             set bbb "000"
             catch { set bbb [format %03d [expr $acb(1) / 100 ]] }
             catch { set bbb [format %03d [expr $acb($x) / 100 ]] }
             set trendfile($x) "/home/abacus/trenddatafiles/trend.$bbb.$timb.dat"
           }
           #catch { ${w}t.timb configure -text "Timebase ($timb sec)" }
           catch { get_data }
         }
}
#catch { ${w}t.timb configure -text "Timebase ($timb sec)" }
#

set xpoints $SAMPLES
menubutton ${w}t.xpoints -text "time zoom" -menu ${w}t.xpoints.m  -underline 0
menu ${w}t.xpoints.m -tearoff 0
${w}t.xpoints.m add separator
foreach xpoints { 10 50 100 200 500 1000 2000  } {
	${w}t.xpoints.m add radiobutton -label  "Show $xpoints samples"\
	 -variable xpoints -value $xpoints \
         -command { .frame.graph xaxis configure -min -$xpoints -max 0
             #catch { ${w}t.xpoints configure -text "time zoom ($xpoints samples)"  } }
}
#catch { ${w}t.xpoints configure -text "time zoom ($xpoints samples)"  }

set xpoints $SAMPLES



proc clearvars {} {
   global NODE  xmag ymag canvasbg c linesymbol
   global NODE  acb trendfile ymax ymin colour width
   global xVec yVec0 yVec1 yVec2 yVec3 yVec4 yVec5 yVec6 yVec7 yVec8 yVec9

   catch { vector delete xVec yVec0 yVec1 yVec2 yVec3 yVec4 yVec5 yVec6 yVec7 yVec8 yVec9}
   catch { vector create xVec yVec0 }
   catch { vector create yVec1 yVec2 }
   catch { vector create yVec3 yVec4 }
   catch { vector create yVec5 yVec6 }
   catch { vector create yVec7 yVec8 }
   catch { vector create yVec9}
   
   foreach X {1 2 3 4 5 6 7 8 9 } {
     catch { .frame.graph axis create line$X }
     catch { .frame.graph element create line$X }
     catch { .frame.graph axis create yy$X  }
     catch { .frame.graph element create line$X -pixels $width($X) }
   }
   set canvasbg #d9d9d9
   set colour(0)   black
   set colour(1)   red
   set colour(2)   blue
   set colour(3)   green
   set colour(4)   brown
   set colour(5)   orange
   set colour(6)   cyan3
   set colour(7)   white
   set colour(8)   SeaGreen3
   set colour(9)   PaleGreen4
   
   foreach var {0 1 2 3 4 5 6 7 8 9} {
	   eval {set acb($var)  	   ""}
	   eval {set trendfile($var)	   ""}
	   eval {set ymax($var) 	   100.0}
	   eval {set ymin($var) 	   0.0}
	   eval {set width($var)	   2}
	   eval {set linesymbol($var)	   "none"}
	   }
   
   set xmag	   1.0
   set ymag	   1.0
   set timb        060

   }

set auto_upp 0
set auto_upp 1
button ${w}t.auto -text "auto updating" -command {
  set auto_upp 1
  after cancel drawlines
  drawlines
  }
button ${w}t.hand -text "stop updating" -command {
  set auto_upp 0
  .frame2.text1 insert 1.0 [format " Update manually " t ]
  after cancel drawlines
  }
button ${w}t.updat -text "update now" -command {
  set auto_upp 0
  get_data
  }


button ${w}t.ps -text "make psfile" -command {
 global TRENDFILESDIR
 after cancel [after info]
 $c postscript -file  \
 [tk_getSaveFile -initialdir $TRENDFILESDIR -initialfile trend.ps]\
 -height 330 -width 500 -rotate 1 
 }


clearvars

set times "No data available yet"

proc time_conv { crap index1 } {
  global times
  set retval "unknown"
  catch { set retval  [lindex $times [expr 0 - $index1]] }
  
#  catch { puts stdout "time_conv { $crap $index1 } \[expr 0 - \$index1\] = [expr 0 - $index1] -> $retval" }
  return $retval
}


  ####   ######   #####          #####     ##     #####    ##
 #    #  #          #            #    #   #  #      #     #  #
 #       #####      #            #    #  #    #     #    #    #
 #  ###  #          #            #    #  ######     #    ######
 #    #  #          #            #    #  #    #     #    #    #
  ####   ######     #   #######  #####   #    #     #    #    #

proc get_data {} {
  global NODE canvasbg trendfile acb colour width updateint SAMPLES times ymax ymin linesymbol
   global xVec0 xVec yVec0 yVec1 yVec2 yVec3 yVec4 yVec5 yVec6 yVec7 yVec8 yVec9
   global thefile timb w si
  
  after cancel get_data ; after 1000
  
  foreach x {0 1 2 3 4 5 6 7 8 9} {
    set bbb "000"
    catch { set bbb [format %03d [expr $acb(1) / 100 ]] }
    catch { set bbb [format %03d [expr $acb($x) / 100 ]] }
    set trendfile($x) "/home/abacus/trenddatafiles/trend.$bbb.$timb.dat"
  }

  wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile (getting data)"
  catch { .frame.graph configure  -title "ABACUS4 Trend System [BashNet $NODE date]" }

  catch {   set times2  [BashNet $NODE ./trendmem $trendfile(0) get 0 $SAMPLES ] }
  catch {   regsub -all "\n" $times2 " " times }

#### 
 catch { .frame.graph configure -plotbackground $canvasbg }

  for {set x 1} {$x < 10} {incr x} { set si($x) [BashNet $NODE ./si $acb($x)] }
  for {set x 1} {$x < 10} {incr x} {
        catch { .frame.graph element configure line$x -symbol $linesymbol($x)   -linewidth $width($x) -color $colour($x) -xdata xVec -ydata  yVec$x }
        catch { .frame.graph element configure line$x -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" $acb($x) $si($x) [BashNet $NODE ./ra2 $acb($x)] $ymin($x) $ymax($x)] }
  }

  for {set x 1} {$x < 10} {incr x} {
      catch { .frame.graph element configure line$x -mapy yy$x  }
      catch { .frame.graph axis configure yy$x -min $ymin($x) -max $ymax($x) }
      catch { .frame.graph axis configure yy$x -title [format "%-24.24s" $si($x) ] }
      catch { .frame.graph axis configure yy$x -color $colour($x) }
      catch { .frame.graph axis configure yy$x -titlecolor $colour($x) }
      catch { .frame.graph axis configure yy$x -scrollcommand { yscroll_set } }
  }

  catch { .frame.graph configure  -title "ABACUS4 Trend System [BashNet $NODE date]" }

  catch {   xVec  set [BashNet $NODE ./trendmem $trendfile(1) get $acb(1) $SAMPLES | cut -d ' ' -f 1] }

  for {set x 1} {$x < 10} {incr x} {
        catch {  if {$acb($x) > 0} {   yVec$x set [BashNet $NODE ./trendmem $trendfile($x) get $acb($x) $SAMPLES | cut -d ' ' -f 2] } else {  yVec$x set 0 } }
  }

  for {set x 1} {$x < 10} {incr x} {
      catch { .frame.graph element configure line$x -mapy yy$x  }
      catch { .frame.graph axis configure yy$x -min $ymin($x) -max $ymax($x) }
      catch { .frame.graph axis configure yy$x -title [format "%-24.24s" $si($x) ] }
      catch { .frame.graph axis configure yy$x -color $colour($x) }
      catch { .frame.graph axis configure yy$x -titlecolor $colour($x) }
      catch { .frame.graph axis configure yy$x -scrollcommand { yscroll_set } }
  }

  catch { .frame.graph configure  -title "ABACUS4 Trend System [BashNet $NODE date]" }
  wm title $w "ABACUS Trend Display [info script] ${NODE}::$thefile"
  after [expr 1000 * $updateint] get_data
}


 ######  #    #  #####            ####   ######
 #       ##   #  #    #          #    #  #
 #####   # #  #  #    #          #    #  #####
 #       #  # #  #    #          #    #  #
 #       #   ##  #    #          #    #  #
 ######  #    #  #####            ####   #


  ####   ######   #####          #####     ##     #####    ##
 #    #  #          #            #    #   #  #      #     #  #
 #       #####      #            #    #  #    #     #    #    #
 #  ###  #          #            #    #  ######     #    ######
 #    #  #          #            #    #  #    #     #    #    #
  ####   ######     #   #######  #####   #    #     #    #    #

#pack ${w}t.newf ${w}t.newp ${w}t.ps ${w}t.save ${w}t.close  -side left
#pack ${w}t.newf ${w}t.newp ${w}t.save ${w}t.updat  ${w}t.close  -side left
#pack ${w}t.newf ${w}t.newp ${w}t.auto ${w}t.hand ${w}t.updat  ${w}t.close  -side left
#pack ${w}t.samples ${w}t.xpoints ${w}t.newf ${w}t.newp ${w}t.save ${w}t.zoom1  ${w}t.updat ${w}t.close  -side left
#pack ${w}t.samples ${w}t.xpoints ${w}t.timb ${w}t.revert ${w}t.newf  ${w}t.save  ${w}t.updat ${w}t.option ${w}t.close  -side left

 #####     ##     ####   #    #
 #    #   #  #   #    #  #   #
 #    #  #    #  #       ####
 #####   ######  #       #  #
 #       #    #  #    #  #   #
 #       #    #   ####   #    #

pack ${w}t.file ${w}t.samples ${w}t.xpoints ${w}t.timb  -side left -anchor ne


frame .frame
# pack .frame -side top -fill both -expand yes
set canvasbg #d9d9d9

graph .frame.graph -height 18i -width 18i
catch { .frame.graph configure -backgound $canvasbg }
.frame.graph configure -plotbackground black
.frame.graph configure  -title "ABACUS4 Trend System [BashNet $NODE date]"
.frame.graph grid configure -hide no

scrollbar .frame.xbar -command { .frame.graph axis view x } -orient horizontal
# scrollbar .frame.ybar -command { .frame.graph axis view y } -orient vertical
scrollbar .frame.ybar -command { frameybar } -orient vertical

proc yscroll_set { {arg1 0} {arg2 0}  } {
#  puts stdout "yscroll_set arg1=$arg1 arg2=$arg2 "
  catch { .frame.ybar set [expr $arg1 / 10] [expr $arg2 / 10] }
}

proc frameybar { arg1 arg2 {arg3  0}} {
# puts stdout "frameybar arg1=$arg1 arg2=$arg2 arg3=$arg3"
 
 if { $arg1 == "moveto"} {
   foreach x {1 2 3 4 5 6 7 8 9} {
     catch { .frame.graph axis view yy$x  $arg1 [expr $arg2 * 10] } }
 }
}

#scrollbar .frame.ybar -command { .frame.graph axis view y } -orient horizontal
.frame.graph axis configure x -scrollcommand { .frame.xbar set } ;# -logscale no -loose no
.frame.graph axis configure y -scrollcommand { yscroll_set } ;# -logscale no  
.frame.graph axis configure x -command time_conv

foreach X {1 2 3 4 5 6 7 8 9 } {
  catch { .frame.graph axis create yy$X  }
  catch { .frame.graph element create line$X -pixels $width($X) }
}
### catch { .frame.graph yaxis use { y1 y2 y3 y4 y5  } }
### catch { .frame.graph y2axis use { y6 y7 y8 y9 } }
### catch { .frame.graph y2axis configure -hide false }
### catch { .frame.graph yaxis use { yy1 yy2 yy3 yy4 yy5 yy6  } }


catch { .frame.graph  legend configure -font fixed -position bottom }


# 
pack .frame -fill both -expand yes

label .frame.current -text "Click over graph to update this"

table .frame \
    0,0 .frame.graph  -fill both  \
    1,0 .frame.xbar -fill x   \
    2,0 .frame.current 

#    0,1 .frame.ybar -fill y  -padx 0 -pady 0 \

#wm geometry . 800x600+8+24

proc change_yaxis { graph } {
   $graph  yaxis use yy[string range [$graph legend get current] 4 4]
# catch { .frame.graph yaxis use { yy1 yy2 yy3 yy4 yy5 yy6 } }
}

.frame.graph yaxis use yy1

proc ActiveLegend { graph } {
    $graph legend bind all <Motion> {  }  
    $graph legend bind all <Enter> [list blt_ActivateLegend $graph ]
    $graph legend bind all <Leave> [list blt_DeactivateLegend $graph]
    $graph legend bind all <ButtonPress-3> [list blt::HighlightLegend $graph]
    $graph legend bind all <ButtonPress-2> [list change_yaxis $graph]
    $graph legend bind all <ButtonPress-1> [list do_b1 $graph]
}

proc blt_ActivateLegend { graph } {
    set elem [$graph legend get current]
    $graph legend activate $elem
#    $graph  yaxis use yy[string range [$graph legend get current] 4 4]
#    puts stdout "$graph  yaxis use yy[string range [$graph legend get current] 4 4]"
    
}
proc blt_DeactivateLegend { graph } {
    set elem [$graph legend get current]
    $graph legend deactivate $elem
}






set symbol "none"

proc do_b1 { graph } {
    global ygroup ymin ymax do_b1_x acb
    global symbol linesymbol width
    

    catch { destroy .do_b1 }
    toplevel .do_b1 
    label .do_b1.label -text "Configure [$graph legend get current] ([$graph  element cget [$graph legend get current] -label])"
    button .do_b1.bquit -text "close" -command { 
#      after cancel get_data
#      get_data
      destroy .do_b1 
    }
    
##    pack .do_b1.label .do_b1.bquit

    button .do_b1.show -text "show curve" -command { .frame.graph line configure line$do_b1_x -hide 0 }
    button .do_b1.hide -text "hide curve" -command { .frame.graph line configure line$do_b1_x -hide 1 }
    
    
    set do_b1_x [string range [$graph legend get current] 4 4]
    entry .do_b1.emin 
    .do_b1.emin insert end $ymin($do_b1_x) 
    button .do_b1.bmin -text "change min" -command { 
       global ygroup ymin ymax do_b1_x
       catch { set ymin($do_b1_x) [.do_b1.emin get] }
       catch { .frame.graph axis configure yy$do_b1_x -min $ymin($do_b1_x) -max $ymax($do_b1_x) }
#       puts stdout "set ymin($do_b1_x) ($ymin($do_b1_x)) [.do_b1.emin get] "
#       puts stdout " .frame.graph axis configure yy$do_b1_x -min $ymin($do_b1_x) -max $ymax($do_b1_x)"
     }
    entry .do_b1.emax 
    .do_b1.emax insert end $ymax($do_b1_x)
#    button .do_b1.bmax -text "change max" -command { }
    button .do_b1.bmax -text "change max" -command { 
       global ygroup ymin ymax do_b1_x
       set ymax($do_b1_x) [.do_b1.emax get]
       catch { .frame.graph axis configure yy$do_b1_x -min $ymin($do_b1_x) -max $ymax($do_b1_x) }
#       puts stdout "set ymax($do_b1_x) ($ymax($do_b1_x)) [.do_b1.emax get] "
#       puts stdout " .frame.graph axis configure yy$do_b1_x -min $ymin($do_b1_x) -max $ymax($do_b1_x)"
     }
     
     entry .do_b1.eacb -text  $acb($do_b1_x) 
     button .do_b1.bacb -text "change acb ($acb($do_b1_x))" -command {
         find_acb_block $do_b1_x
      }
     
     button .do_b1.colour -text "change pen colour" -command {
		set colour1 [tk_chooseColor -initialcolor $colour($do_b1_x)]
		if { $colour1 != "" } {
			set colour($do_b1_x) $colour1
			catch { .frame.graph line configure line$do_b1_x -color $colour($do_b1_x) }
			}
     }
     
     entry .do_b1.ewidth
     .do_b1.ewidth insert end $width($do_b1_x) 
     button .do_b1.bwidth -text "change pen width" -command {
		catch { set width1 [.do_b1.ewidth get] }
		if { $width1 != "" } {
			set width($do_b1_x) $width1
			catch { .frame.graph line configure line$do_b1_x -symbol $linesymbol($do_b1_x) -pixels $width($do_b1_x) }
			}
     }
     
    set symbol [.frame.graph line cget line$do_b1_x -symbol]
    menubutton .do_b1.symbol -text "choose pen symbol" -menu .do_b1.symbol.m -underline 0
    menu .do_b1.symbol.m -tearoff 0
    .do_b1.symbol.m  add separator
    foreach typ { "none" "circle" "square" "diamond" "plus" "cross" "splus" "scross" "triangle" "arrow" } {
      .do_b1.symbol.m  add radiobutton -label  "$typ"\
        -variable symbol -value $typ \
        -command { catch { global symbol linesymbol width
                           set linesymbol($do_b1_x) $symbol
                           .frame.graph line configure line$do_b1_x -symbol $linesymbol($do_b1_x) -pixels $width($do_b1_x) } }
    }

     grid .do_b1.label   -row 0  -column 0 -rowspan 1 -columnspan 2 -sticky news
     grid .do_b1.bquit   -row 99 -column 1 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.emax    -row 3  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.bmax    -row 3  -column 1 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.emin    -row 4  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.bmin    -row 4  -column 1 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.eacb    -row 5  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.bacb    -row 5  -column 1 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.ewidth  -row 6  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.bwidth  -row 6  -column 1 -rowspan 1 -columnspan 1 -sticky news

     grid .do_b1.show    -row 7  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.hide    -row 7  -column 1 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.symbol  -row 8  -column 0 -rowspan 1 -columnspan 1 -sticky news
     grid .do_b1.colour  -row 8  -column 1 -rowspan 1 -columnspan 1 -sticky news
    
#    puts stdout "B1 on [$graph legend get current]"
}

ActiveLegend .frame.graph

# Blt_ZoomStack .frame.graph
# Blt_Crosshairs .frame.graph
.frame.graph crosshairs off 


# Blt_ClosestPoint .frame.graph
# Blt_PrintKey .frame.graph


proc setcanvasbg {} {
	global NODE canvasbg w
	set canvasbg1 [tk_chooseColor -initialcolor $canvasbg]
	if { $canvasbg1 != "" } {
		set canvasbg $canvasbg1
		after cancel [after info]
                get_data
		}
	}
##bind .frame.graph <3> "setcanvasbg"

# Ask for and then get the trendfile
#${w}t.newf invoke 

#${w}t.revert invoke 


# -halo 500
proc do_Motion { W x y } {
  global clos si acb 
  global NODE canvasbg trendfile acb colour width updateint SAMPLES times ymax ymin linesymbol
  global xVec0 xVec yVec0 yVec1 yVec2 yVec3 yVec4 yVec5 yVec6 yVec7 yVec8 yVec9
  global thefile timb w si SAMPLES xpoints
  
  if { $x == 0 } {

    .frame.graph crosshairs off 
    set xconv 0
    set timdat [time_conv crap  [format "%5.0f" [lindex $xconv 0] ]]
    set xconv2 [format "%5.0f" [expr 0 - [lindex $xconv 0]] ]
    .frame.current configure -text \
     "Above values at $timdat, NODE=$NODE  \
      $SAMPLES SAMPLES of which $xpoints are visible. timb=$timb seconds (x=$x y=$y)"

  } else {

    .frame.graph crosshairs on 
    .frame.graph crosshairs configure -position @$x,$y

    set xconv [$W invtransform $x $y]
    set timdat [time_conv crap  [format "%5.0f" [lindex $xconv 0] ]]
    set xconv2 [format "%5.0f" [expr 0 - [lindex $xconv 0]] ]
    .frame.current configure -text \
     "Above values at $timdat, NODE=$NODE  \
      $SAMPLES SAMPLES of which $xpoints are visible. timb=$timb seconds (x=$x y=$y)"
  } 

        catch { .frame.graph element configure line1 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(1) $si(1) \
          $yVec1($xconv2) $ymin(1) $ymax(1)] }
        catch { .frame.graph element configure line2 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(2) $si(2) \
          $yVec2($xconv2) $ymin(2) $ymax(2)] }
        catch { .frame.graph element configure line3 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(3) $si(3) \
          $yVec3($xconv2) $ymin(3) $ymax(3)] }
        catch { .frame.graph element configure line4 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(4) $si(4) \
          $yVec4($xconv2) $ymin(4) $ymax(4)] }
        catch { .frame.graph element configure line5 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(5) $si(5) \
          $yVec5($xconv2) $ymin(5) $ymax(5)] }
        catch { .frame.graph element configure line6 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(6) $si(6) \
          $yVec6($xconv2) $ymin(6) $ymax(6)] }
        catch { .frame.graph element configure line7 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(7) $si(7) \
          $yVec7($xconv2) $ymin(7) $ymax(7)] }
        catch { .frame.graph element configure line8 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(8) $si(8) \
          $yVec8($xconv2) $ymin(8) $ymax(8)] }
        catch { .frame.graph element configure line9 \
         -label [format "%4d %-24.24s %7.2f (%7.2f..%7.2f)" \
          $acb(9) $si(9) \
          $yVec9($xconv2) $ymin(9) $ymax(9)] }

	keep_clean
}

proc keep_clean {} {
  global clos si acb 
  global NODE canvasbg trendfile acb colour width updateint SAMPLES times ymax ymin linesymbol
   global xVec0 xVec yVec0 yVec1 yVec2 yVec3 yVec4 yVec5 yVec6 yVec7 yVec8 yVec9
   global thefile timb w si SAMPLES xpoints 

  after cancel keep_clean
  for {set x 1} {$x < 10} {incr x} {
      catch { .frame.graph element configure line$x -mapy yy$x  }
      catch { .frame.graph axis configure yy$x -min $ymin($x) -max $ymax($x) }
      catch { .frame.graph axis configure yy$x -title [format "%-24.24s" $si($x) ] }
      catch { .frame.graph axis configure yy$x -color $colour($x) }
      catch { .frame.graph axis configure yy$x -titlecolor $colour($x) }
      catch { .frame.graph axis configure yy$x -scrollcommand { yscroll_set } }
  }
  after 1000 keep_clean
}
keep_clean

#bind .frame.graph <2> { do_Motion %W %x %y }  
#bind .frame.graph <Motion> { do_Motion %W %x %y }  
bind .frame.graph <1> { do_Motion %W %x %y }  
#bind .frame.graph <Leave> { do_Motion %W 0 0 }  
bind .frame.graph <2> { do_Motion %W 0 0  }  
bind .frame.graph <3> { do_Motion %W 0 0  }  

.frame.graph configure -font *-Helvetica-Bold-R-Normal-*-14-140-*
#.frame.graph configure -plotpadx 0
#.frame.graph configure -plotpady 0

#for {set xx 0} {$xx < 50} {incr xx} { puts stdout "$yVec1($xx) $yVec2($xx) $yVec3($xx) $yVec4($xx) $yVec5($xx) $yVec6($xx)"  }
proc tableout {} {
  global yVec1 yVec2 yVec3 yVec4 yVec5 sampl
  global yVec6 yVec7 yVec8 yVec9 yVec10 xVec
  
  set txtfile [tk_getSaveFile -initialdir /tmp/ -initialfile trend.txt]
  if { $txtfile != ""} { 
     set fileId [open $txtfile w]

     catch { append line "\t[.frame.graph axis cget yy1 -title]" }
     catch { append line "\t[.frame.graph axis cget yy2 -title]" }
     catch { append line "\t[.frame.graph axis cget yy3 -title]" }
     catch { append line "\t[.frame.graph axis cget yy4 -title]" }
     catch { append line "\t[.frame.graph axis cget yy5 -title]" }
     catch { append line "\t[.frame.graph axis cget yy6 -title]" }
     catch { append line "\t[.frame.graph axis cget yy7 -title]" }
     catch { append line "\t[.frame.graph axis cget yy8 -title]" }
     catch { append line "\t[.frame.graph axis cget yy9 -title]" }
     catch { puts $fileId "$line" }
     catch { puts $fileId "" }
     set line ""
     
     for {set xx $sampl} {$xx >= 0} {incr xx -1} {
       catch { set line "[time_conv crap [format %4.0f $xVec($xx)]]"
       catch { append line [format "\t%g" $yVec1($xx)] }
       catch { append line [format "\t%g" $yVec2($xx)] }
       catch { append line [format "\t%g" $yVec3($xx)] }
       catch { append line [format "\t%g" $yVec4($xx)] }
       catch { append line [format "\t%g" $yVec5($xx)] }
       catch { append line [format "\t%g" $yVec6($xx)] }
       catch { append line [format "\t%g" $yVec7($xx)] }
       catch { append line [format "\t%g" $yVec8($xx)] }
       catch { append line [format "\t%g" $yVec9($xx)] }
       catch { puts $fileId "$line" } }
     }
     close $fileId
  }
}

######################## listboxes stuff #############################
proc Scroll_Set {scrollbar geoCmd offset size} {
	if {$offset != 0.0 || $size != 1.0} {
		eval $geoCmd		  ;# Make sure it is visible
		$scrollbar set $offset $size
	} else {
		set manager [lindex $geoCmd 0]
		$manager forget $scrollbar								;# hide it
	}
}

proc Scroll_Set_2 {scrollbar geoCmd offset size} {
		eval $geoCmd		  ;# Make sure it is visible
		$scrollbar set $offset $size
}

proc Scrolled_Listbox { f args width_15 height_12 } {
	frame $f
	listbox $f.list -width $width_15 -height $height_12 -font -adobe-courier-bold-r-*-*-12-*-*-*-*-*-*-*\
		-xscrollcommand [list Scroll_Set $f.xscroll \
			[list grid $f.xscroll -row 1 -column 0 -sticky we]] \
		-yscrollcommand [list Scroll_Set_2 $f.yscroll \
			[list grid $f.yscroll -row 0 -column 1 -sticky ns]]

	scrollbar $f.xscroll -orient horizontal -command [list $f.list xview]
	scrollbar $f.yscroll -orient vertical -command [list $f.list yview]
	grid $f.list $f.yscroll -sticky news
	grid $f.xscroll -sticky news
	grid rowconfigure $f 0 -weight 1
	grid columnconfigure $f 0 -weight 1
	return $f.list
}

proc Scrolled_Listbox_2 { f args width_15 height_12 } {
	frame $f
	listbox $f.list -width $width_15 -height $height_12 -font -adobe-courier-bold-r-*-*-12-*-*-*-*-*-*-*\
		-xscrollcommand [list Scroll_Set_2 $f.xscroll \
			[list grid $f.xscroll -row 1 -column 0 -sticky we]] \
		-yscrollcommand [list Scroll_Set_2 $f.yscroll \
			[list grid $f.yscroll -row 0 -column 1 -sticky ns]]

	scrollbar $f.xscroll -orient horizontal -command [list $f.list xview]
	scrollbar $f.yscroll -orient vertical -command [list $f.list yview]
	grid $f.list $f.yscroll -sticky news
	grid $f.xscroll -sticky news
	grid rowconfigure $f 0 -weight 1
	grid columnconfigure $f 0 -weight 1
	return $f.list
}

proc find_all_block { type } {
 global w thetagfile tagslist m blockno NODE

 set blrange [exec grep "$type" /home/abacus/abacus.sys]

 set allblox [exec  /home/abacus/engnet $NODE b[lindex $blrange 0],xb[lindex $blrange 1],long,.si  | cut -c 2-60 | sed -e "s/^/{/" -e "s/$/}/"  ]
 
 catch { destroy .allblocks }
 toplevel .allblocks
 wm title .allblocks "$type blocks"

 set alllistblox [Scrolled_Listbox .allblocks.alllistblox  $allblox  45 12]
 $alllistblox delete 0 end
 foreach blk $allblox {
 	$alllistblox insert end $blk
 	}
 $alllistblox delete 0 1
 
 button .allblocks.close -text "close" -command { destroy .allblocks }
 pack .allblocks.alllistblox .allblocks.close 
 
 bind $alllistblox <ButtonRelease-1> { 
 	set blockno 0
 	set blockno_temp [string trim [eval "%W get @%x,%y"] ]
 	eval { scan $blockno_temp { %%d} blockno }
	catch { destroy $alllistblox }
  
 }

}
proc find_acb_block { do_b1_x } {
 global w thetagfile tagslist m blockno NODE alllistblox
 global acb

# set blrange [exec grep "$type" /home/abacus/abacus.sys]
 set blrange "1 8999"
 set blrange "8001 8999"

 set allblox [exec  /home/abacus/engnet $NODE b[lindex $blrange 0],xb[lindex $blrange 1],long,.si  | cut -c 2-60 | sed -e "s/^/{/" -e "s/$/}/"  ]
 append allblox [format "\nblank\n\n"]
# set allblox1 [exec  /home/abacus/engnet $NODE b[lindex $blrange 0],xb[lindex $blrange 1],long,.si  | cut -c 2-60 | sed -e "s/^/{/" -e "s/$/}/"  ]
 
# regsub -all "(....)...(....................)" $allblox1 "\1 \2" allblox
 
 catch { destroy .allblocks }
 toplevel .allblocks
 wm title .allblocks "Alarm code blocks"

 set alllistblox [Scrolled_Listbox .allblocks.alllistblox  $allblox  45 12]
 $alllistblox delete 0 end
 foreach blk $allblox {
 	$alllistblox insert end $blk
 	}
 $alllistblox delete 0 1
 
 button .allblocks.cancel -text "cancel" -command { destroy .allblocks }
 set blockno 0
 button .allblocks.close -text "Change ACB" -command { 
    if { $blockno > 0 } {
        set acb($do_b1_x) $blockno
        catch { .do_b1.eacb delete 0 end }
        catch { .do_b1.eacb insert end $acb($do_b1_x) }
        catch { .do_b1.eacb configure -text "$acb($do_b1_x)" }
   }
   destroy .allblocks 
 }
 pack .allblocks.alllistblox .allblocks.close  .allblocks.cancel 
 
 bind $alllistblox <ButtonRelease-1> { 
 	global acb
        
        set blockno "0"
 	set blockno_temp [string trim [eval "%W get @%x,%y"] ]
 	catch { scan $blockno_temp { %%d} blockno }
        if { $blockno == "blank" } {
          set acb($do_b1_x) ""
          catch { .do_b1.eacb delete 0 end }
          catch { .do_b1.eacb insert end $acb($do_b1_x) }
          catch { .do_b1.eacb configure -text "$acb($do_b1_x)" }
          
        } elseif { $blockno == "0" } {
          set acb($do_b1_x) ""
          catch { .do_b1.eacb delete 0 end }
          catch { .do_b1.eacb insert end $acb($do_b1_x) }
          catch { .do_b1.eacb configure -text "$acb($do_b1_x)" }
          
        } else {
          set acb($do_b1_x) $blockno
          catch { .do_b1.eacb delete 0 end }
          catch { .do_b1.eacb insert end $acb($do_b1_x) }
          catch { .do_b1.eacb configure -text "$acb($do_b1_x)" }
        }
  
 }

}

proc choose_acb {} {
  
}


revert_to_org
